--------------------------------------------------
-- Player Classes Script by Unreal Software     --
-- 28.02.2009 - www.UnrealSoftware.de           --
-- Adds Player Classes to your server           --
--------------------------------------------------

if sample==nil then sample={} end
sample.classes={}

-----------------------
-- INITIAL SETUP     --
-----------------------
function initArray(m)
	local array = {}
	for i = 1, m do
		array[i]=0
	end
	return array
end
sample.classes.class=initArray(32)
function sample.classes.classmenu(id)
	menu(id,"Select your Class,Soilder|Balanced,Runner|speed,Builder|building,Sniper|AWP,Wing-Man|Riot Shield")	
end


-----------------------
-- TEAM -> CLASS     --
-----------------------
addhook("team","sample.classes.team")
function sample.classes.team(id,team)
	if (team>0) then
		sample.classes.classmenu(id)
	end
end


-----------------------
-- SERVERACTION      --
-----------------------
addhook("serveraction","sample.classes.serveraction")
function sample.classes.serveraction(id)
	sample.classes.classmenu(id)
end


-----------------------
-- CLASS SELECTION   --
-----------------------
addhook("menu","sample.classes.menu")
function sample.classes.menu(id,menu,sel)
	if (menu=="Select your Class") then
		if (sel>=0 and sel<=5) then
			sample.classes.class[id]=sel
			if (player(id,"health")>0) then
				parse("killplayer "..id)
			end
		end
	end
end


-----------------------
-- SPAWN             --
-----------------------
addhook("spawn","sample.classes.spawn")
function sample.classes.spawn(id)
	-- Soilder
	if (sample.classes.class[id]<=1) then
		parse ("setmaxhealth "..id.." 100")
		parse ("setarmor "..id.." 50")
		parse ("speedmod "..id.." 0")
		return "11,32,51,52,52";
	end
	-- Runner
	if (sample.classes.class[id]==2) then
		parse ("setmaxhealth "..id.." 90")
		parse ("setarmor "..id.." 0")
		parse ("speedmod "..id.." 8")
		return "22,3,51,52,52";
	end
	-- Builder
	if (sample.classes.class[id]==3) then
		parse ("setmaxhealth "..id.." 150")
		parse ("setarmor "..id.." 0")
		parse ("speedmod "..id.." 4")
		return "3,74,51,52,52";
	end
	-- Sniper
	if (sample.classes.class[id]==4) then
		parse ("setmaxhealth "..id.." 100")
		parse ("setarmor "..id.." 0")
		return "35,1,51,53";
	end
	-- Wing-Man
	if (sample.classes.class[id]==5) then
		parse ("setmaxhealth "..id.." 70")
		parse ("setarmor "..id.." 20")
		parse ("speedmod "..id.." 5")
		return "41,4,51,52,52";
	end
end


-----------------------
-- NO BUYING         --
-----------------------
addhook("buy","sample.classes.buy")
function sample.classes.buy()
	return 1
end


-----------------------
-- NO DROPPING       --
-----------------------

addhook("spawn", "pentagon")
function pentagon(id)
if player(id,"team") == 1 then
parse("setmoney "..id.." 10000")
elseif player(id,"team") == 2 then
parse("setmoney "..id.." 10000")
end
end

addhook("second","healsystem")
function healsystem()
for id=1,32 do
if player(id,"exists") then
parse("sethealth "..id.." "..player(id,"health")+0)
end
end
end

tdm = {}
-- Final score, 0 to disable
tdm.FinalScore = 200
-----------
tdm.CTscore = 0
tdm.Tscore = 0
tdm.End = false

addhook('die','tdm.kill')
function tdm.kill(k)
	if tdm.End == false then
		if player(k,'team') == 1 then tdm.CTscore = tdm.CTscore + 1; tdm.update(); end
		if player(k,'team') == 2 then tdm.Tscore = tdm.Tscore + 1; tdm.update(); end
		if tdm.Tscore == tdm.FinalScore and tdm.FinalScore ~= 0 then msg('225050050'..tdm.Tscore..' - '..tdm.CTscore..'! Terrorists win!'); parse("sv_sound \"radio/terwin.ogg\""); tdm.End = true; timer(5000,"tdm.restart") end
		if tdm.CTscore == tdm.FinalScore and tdm.FinalScore ~= 0 then msg('065105225'..tdm.CTscore..' - '..tdm.Tscore..'! Counter-Terrorists win!'); parse("sv_sound \"radio/ctwin.ogg\""); tdm.End = true; timer(5000,"tdm.restart") end
	end
end

function tdm.restart()
parse('restart')
end

function tdm.update()
	if tdm.End == false then
		for i = 1,game('sv_maxplayers') do
			if player(i,'exists') and player(i,'team') == 1 then
				parse('hudtxt2 '..i..' 1 "225050050T: '..tdm.Tscore..' / '..tdm.FinalScore..'" 320 15 2')
				parse('hudtxt2 '..i..' 2 "065105225CT: '..tdm.CTscore..' / '..tdm.FinalScore..'" 320 30 2')
			end
			if player(i,'exists') and player(i,'team') == 2 then
				parse('hudtxt2 '..i..' 2 "065105225CT: '..tdm.CTscore..' / '..tdm.FinalScore..'" 320 15 2')
				parse('hudtxt2 '..i..' 1 "225050050T: '..tdm.Tscore..' / '..tdm.FinalScore..'" 320 30 2')
			end
			if player(i,'team') == 0 then
				parse('hudtxt2 '..i..' 1 "T: '..tdm.Tscore..' / '..tdm.FinalScore..'" 330 45 2')
				parse('hudtxt2 '..i..' 2 "CT: '..tdm.CTscore..' / '..tdm.FinalScore..'" 330 60 2')
			end
		end
	end
end

addhook('startround','tdm.startround')
function tdm.startround()
tdm.CTscore = 0
tdm.Tscore = 0
tdm.End = false
tdm.update()
end

addhook('team','tdm.team')
function tdm.team(id,team)
	if team == 1 then
		parse('hudtxt2 '..id..' 1 "225050050T: '..tdm.Tscore..' / '..tdm.FinalScore..'" 320 15 2')
		parse('hudtxt2 '..id..' 2 "065105225CT: '..tdm.CTscore..' / '..tdm.FinalScore..'" 320 30 2')
	end
	if team == 2 then
		parse('hudtxt2 '..id..' 2 "065105225CT: '..tdm.CTscore..' / '..tdm.FinalScore..'" 320 15 2')
		parse('hudtxt2 '..id..' 1 "225050050T: '..tdm.Tscore..' / '..tdm.FinalScore..'" 320 30 2')
	end
	if team == 0 then
		parse('hudtxt2 '..id..' 1 "T: '..tdm.Tscore..' / '..tdm.FinalScore..'" 330 45 2')
		parse('hudtxt2 '..id..' 2 "CT: '..tdm.CTscore..' / '..tdm.FinalScore..'" 330 60 2')
	end
end